#ifndef _periodicdbmaintenance_
#define _periodicdbmaintenance_

#include "../idatabase.h"
#include "../ilogger.h"
#include "../datetime.h"
#include "ifreenetregistrable.h"
#include "iperiodicprocessor.h"

class PeriodicDBMaintenance:public IFreenetRegistrable,public IPeriodicProcessor,public IDatabase,public ILogger
{
public:
	PeriodicDBMaintenance();

	void Process();

	void RegisterWithThread(FreenetMasterThread *thread);

private:
	void Do10MinuteMaintenance();
	void Do30MinuteMaintenance();
	void Do1HourMaintenance();
	void Do6HourMaintenance();
	void Do1DayMaintenance();

	DateTime m_check10mins;
	DateTime m_check30mins;
	DateTime m_check1hour;
	DateTime m_check6hours;
	DateTime m_check1day;
	
};

#endif	// _periodicdbmaintenance_
